DECLARE SUB jascpal (palname$)
DECLARE SUB sjascpal (palname$)
DEFINT A-Z
'This will load a jasc(Paint Shop Pro) palette file in QB, ALOT
'easier than having to convert every palette.
'
'LOAD SYNTAX: jascpal "palname.pal"
'SAVE SYNTAX: sjascpal "palname.pal"
'
'Programmed by:
'Lord Agnathian, Angel Rift Productions
'http://move.to/arp
'agnathian@hotmail.com

SUB jascpal (palname$)
IF INSTR(palname$, ".") = 0 THEN palname$ = palname$ + ".pal"
temp% = FREEFILE
OPEN palname$ FOR INPUT AS #temp%
INPUT #temp%, jpt$
IF UCASE$(jpt$) <> "JASC-PAL" THEN EXIT SUB
INPUT #temp%, jpt$
INPUT #temp%, totcols%
FOR ljp% = 0 TO totcols% - 1
INPUT #temp%, jpt$
jp1% = VAL(LEFT$(jpt$, INSTR(jpt$, CHR$(32))))
jpt$ = RIGHT$(jpt$, LEN(jpt$) - INSTR(jpt$, CHR$(32)))
jp2% = VAL(LEFT$(jpt$, INSTR(jpt$, " ")))
jpt$ = RIGHT$(jpt$, LEN(jpt$) - INSTR(jpt$, CHR$(32)))
jp3% = VAL(jpt$)
OUT &H3C8, ljp%
OUT &H3C9, (jp1% / 255) * 63
OUT &H3C9, (jp2% / 255) * 63
OUT &H3C9, (jp3% / 255) * 63
NEXT
CLOSE #temp%
END SUB

SUB sjascpal (palname$)
DIM jp1 AS LONG
DIM jp2 AS LONG
DIM jp3 AS LONG
IF INSTR(palname$, ".") = 0 THEN palname$ = palname$ + ".pal"
temp% = FREEFILE
OPEN palname$ FOR OUTPUT AS #temp%
PRINT #temp%, "JASC-PAL"
PRINT #temp%, "0100"
PRINT #temp%, "256"
FOR ljp% = 1 TO 256
OUT &H3C8, ljp%
jp1 = INP(&H3C9): jp2 = INP(&H3C9): jp3 = INP(&H3C9)
PRINT #temp%, LTRIM$(STR$(INT((jp1 / 63) * 255))) + " " + LTRIM$(STR$(INT((jp2 / 63) * 255))) + " " + LTRIM$(STR$(INT((jp3 / 63) * 255)))
NEXT
CLOSE #temp%

END SUB

